﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;

namespace _855857_ButtonInRowHeaderVS2010
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.radGridView1.TableElement.RowHeight = 30;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.productsTableAdapter.Fill(this.nwindDataSet.Products);
        }

        private void radGridView1_CreateCell(object sender, GridViewCreateCellEventArgs e)
        {
            if (e.CellType == typeof(GridRowHeaderCellElement))
            {
                e.CellElement = new CustomGridRowHeaderCellElement(e.Column, e.Row);
            }
        }

        public class CustomGridRowHeaderCellElement : GridRowHeaderCellElement
        {
            RadButtonElement btn;
            LightVisualElement imageElement;

            public RadButtonElement Button
            {
                get
                {
                    return btn;
                }
            }

            public LightVisualElement ImageElement
            {
                get
                {
                    return this.imageElement;
                }
            }

            public CustomGridRowHeaderCellElement(GridViewColumn column, GridRowElement row) : base(column, row)
            {
            }

            protected override Type ThemeEffectiveType
            {
                get
                {
                    return typeof(GridRowHeaderCellElement);
                }
            }

            protected override void CreateChildElements()
            {
                base.CreateChildElements();
                this.Children.RemoveAt(0);

                DockLayoutPanel panel = new DockLayoutPanel();

                btn = new RadButtonElement();
                btn.MinSize = new Size(15, 10);
                DockLayoutPanel.SetDock(btn, Telerik.WinControls.Layouts.Dock.Top);

                panel.Children.Add(btn);

                imageElement = new LightVisualElement();
                imageElement.Margin = new System.Windows.Forms.Padding(0, 0, 0, 2);
                panel.Children.Add(imageElement);
                DockLayoutPanel.SetDock(imageElement, Telerik.WinControls.Layouts.Dock.Bottom);
                this.Children.Add(panel);
            }
        }

        private void radGridView1_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            CustomGridRowHeaderCellElement cell = e.CellElement as CustomGridRowHeaderCellElement;
            if (cell != null)
            {
                cell.ImageElement.Image = cell.Image;
                cell.Image = null;
                if (cell.RowInfo.IsCurrent)
                {
                    cell.Button.Visibility = Telerik.WinControls.ElementVisibility.Visible;
                }
                else
                {
                    cell.Button.Visibility = Telerik.WinControls.ElementVisibility.Collapsed;
                }
            }
        }
    }
}